/*
 * uBrainBasic.c
 *
 */ 

#include "global.h"
#include "uart.h"

#include <avr/pgmspace.h>

void board_init() {
	// Disable interrupts
	cli();
	
	// Set clock pre-scaler to /1
	CLKPR = _BV(CLKPCE);
	CLKPR = 0x00;
	
	// Enable interrupts
	sei();
	
	DDRA |= _BV(LED_PIN);
}

void led_pwm_init() {
	// Disable timer interrupts
	TIMSK0 = 0x00;
	// Set Timer A for Fast PWM on OC0B
	TCCR0A = _BV(COM0B1) | _BV(WGM01) | _BV(WGM00);

	// Reset timer
	TCNT0 = 0x00;
	// Set compare value
	OCR0B = 0;

	// Set prescaler to /1 and start pwm
	TCCR0B = _BV(CS02) | _BV(CS00);
}

int main(void)
{
	board_init();
	uart_init();
	led_pwm_init();

    while(1)
    {
		if (bit_is_clear(PINA, SW1_PIN)) {
			OCR0B += 8;
			printf("PWM Value: %u\n", OCR0B);
			_delay_ms(500);
		}
    }
}